/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
/**
 * @module lib/hooks/hapi-16-reply
 * Utility class for hooking the methods we need on the result of
 * Reply.prototype.interface.
 */
'use strict';

const logger = require('../core/logger')('contrast:hooks:hapi');
const moduleHook = require('../hooks/require');
const patcher = require('../hooks/patcher');
const { PATCH_TYPES } = require('../constants');

const handlers = new Set();

function hookReply(Reply) {
  logger.info('hapi loaded. adding response hooks.');

  patcher.patch(Reply.prototype, 'interface', {
    name: 'hapi.Reply.prototype.interface',
    patchType: PATCH_TYPES.FRAMEWORK,
    alwaysRun: true,
    post(data) {
      let reply = data.result;

      handlers.forEach((handler) => {
        reply = handler(reply);
      });

      data.result = reply;
    }
  });
}

function hook(handler) {
  handlers.add(handler);

  moduleHook.resolve({ name: 'hapi', file: 'lib/reply.js' }, hookReply);
  moduleHook.resolve({ name: '@hapi/hapi', file: 'lib/reply.js' }, hookReply);
}

module.exports.hook = hook;
